const APP_DISPLAY_NAME = "Flash Click to View";
const APP_NAME = "flashblock";
const APP_PACKAGE = "/Ted Mielczarek,Ted Drake/flashblock";
const APP_VERSION = "0.8.4";

const APP_JAR_FILE = "flashblock.jar";
const APP_CONTENT_FOLDER = "content/flashblock/";

const APP_SUCCESS_MESSAGE = "Flash objects will now be replaced with a button that you can click on to view them.\n\n";

// start it all up
initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);

// get user's profile chrome directory
var chromef = getFolder("Profile", "chrome");
// add jar file
var err = addFile(APP_PACKAGE, APP_VERSION, APP_JAR_FILE, chromef, null);

var movedUserContent = false;

if(err == SUCCESS) {
	// see if there's an existing userContent.css
	userContent = getFolder(chromef, "userContent.css");
	if(File.exists(userContent) ) { // move it out of the way
		backupuserContent = getFolder(chromef, "userContent-flashblock-backup.css");
	
		// Let it install without complaining for now, the average user won't have a userContent.css file or even know what it is anyhow....
		//  if(File.exists(backupuserContent) ) {
		//    msg = "A backup userContent.css already exists from a orevious install.";
		//    msg += "\nPlease examine and rename/delete the backup before reinstalling.";
		//    alert(msg);
		//    cancelInstall(!err);
		//  }
	
		movedUserContent = true;
		userBackup = getFolder(chromef, "userContent-flashblock-backup.css");
		if(!File.exists(userBackup) ) {
			err = File.copy(userContent, getFolder(chromef,"userContent-flashblock-backup.css"));
		}
	}


	if(err == SUCCESS)
		err = addFile(APP_PACKAGE, APP_VERSION, "userContent.css", chromef, "userContent.css", true);
}

if(err == SUCCESS) { 
	var jar = getFolder(chromef, APP_JAR_FILE);
	registerChrome(CONTENT | PROFILE_CHROME, jar, APP_CONTENT_FOLDER);
	err = performInstall();
	if(err == SUCCESS) {
		msg = APP_NAME + " " + APP_VERSION + " has been succesfully installed.\n"
			+APP_SUCCESS_MESSAGE
			+"Please restart your browser to enable flashblock.";
		if(movedUserContent) {
			msg += "\n!!WARNING!! Your old userContent.css was renamed to userContent-flashblock-backup.css!";
		}
		alert(msg);
	}
	else { 
		alert("Install failed. Error code:" + err);
		cancelInstall(err);
	}
}
else { 
	alert("Install failed. Error code:" + err);
	cancelInstall(err);
}
